/* "rindex.c" */
/*   converts "INDEX" file from Rigaku RAD2 diffractometer */
/*   to "index.txt" */
/* by Takashi IDA, Nov.30, 2001 */

#include <stdio.h>

int main(void)
{
	FILE *fp1,*fp2;
	char buf[256],fname[9],samp[11],dei[9],opr[11];
	int n,i,j;
	short int igon,ism1,ism2,irep,iax,icc;
	double t1,t2,ssp,sw,ft,fu,wl,kv,ma,ds,rs,ss;
	fp1=fopen("INDEX","rb");
	if (fp1==NULL) {
		printf("Error: Could not open the file 'INDEX'\n");
		return 1;
	}
	fp2=fopen("index.txt","wt");
	if (fp2==NULL) {
		printf("Error: Could not open the file 'index.txt'\n");
		fclose(fp1);
		return 1;
	}
	fread(buf,sizeof(char),128,fp1);
	n=(unsigned char)buf[0]+256*(unsigned char)buf[1];
	for (i=1; i<n; i++) {
		fread(buf,sizeof(char),128,fp1);	/*N(8)*/
		for (j=0; j<8;j++) fname[j]=buf[j];
		fname[8]=(char)0x00;
		igon=(unsigned char)buf[8]+256*(unsigned char)buf[9];	/*IGON(2/10)*/
		ism1=(unsigned char)buf[10]+256*(unsigned char)buf[11];	/*SMODE1(2/12)*/
		ism2=(unsigned char)buf[12]+256*(unsigned char)buf[13];	/*SMODE2(2/14)*/
		irep=(unsigned char)buf[14]+256*(unsigned char)buf[15];	/*REP(2/16)*/
		iax=(unsigned char)buf[16]+256*(unsigned char)buf[17];	/*AXIS(2/18)*/
		t1=(unsigned char)buf[18]+256*(unsigned char)buf[19];	/*STARTANG(4/22)*/
		t1=t1*65536+((unsigned char)buf[20]+256*(unsigned char)buf[21]);
		t1/=1000;
		t2=(unsigned char)buf[22]+256*(unsigned char)buf[23];	/*STOANG(4/26)*/
		t2=t2*65536+((unsigned char)buf[24]+256*(unsigned char)buf[25]);
		t2/=1000;
		ssp=(unsigned char)buf[26]+256*(unsigned char)buf[27];	/*SCANSPEED(4/30)*/
		ssp=ssp*65536+((unsigned char)buf[28]+256*(unsigned char)buf[29]);
		ssp/=1000;
		sw=(unsigned char)buf[30]+256*(unsigned char)buf[31];	/*SAMPLEWIDTH(4/34)*/
		sw=sw*65536+((unsigned char)buf[32]+256*(unsigned char)buf[33]);
		sw/=1000;
		ft=(unsigned char)buf[34]+256*(unsigned char)buf[35];	/*FT(2/36)*/
		ft/=100;
		fu=(unsigned char)buf[36]+256*(unsigned char)buf[37];	/*FULL(4/40)*/
		fu=fu*65536+((unsigned char)buf[38]+256*(unsigned char)buf[39]);
		icc=(unsigned char)buf[40]+256*(unsigned char)buf[41];	/*CPS(2/42)*/
		/*(skip)(10/52)*/
		wl=(unsigned char)buf[52]+256*(unsigned char)buf[53];	/*LAMBDA(2/54)*/
		wl/=10000;
		/*I0,I1,I2(6/60)*/
		kv=(unsigned char)buf[60]+256*(unsigned char)buf[61];	/*KV(2/62)*/
		kv/=10;
		ma=(unsigned char)buf[62]+256*(unsigned char)buf[63];	/*MA(2/64)*/
		ma/=10;
		ds=(unsigned char)buf[64]+256*(unsigned char)buf[65];	/*DS(2/66)*/
		ds/=100;
		rs=(unsigned char)buf[66]+256*(unsigned char)buf[67];	/*SS(2/68)*/
		rs/=100;
		ss=(unsigned char)buf[68]+256*(unsigned char)buf[69];	/*RS(2/70)*/
		ss/=100;
		/*TEMP(6,76)*/
		/*OFSET(2,78)*/
		/*MEMO(22,100)*/
		for (j=0;j<10;j++) samp[j]=buf[100+j];	/*SAMPLE(10,110)*/
		samp[10]=(char)0x00;
		for (j=0;j<8;j++) dei[j]=buf[110+j];	/*DEI(8,118)*/
		dei[8]=(char)0x00;
		for (j=0;j<10;j++) opr[j]=buf[118+j];	/*MNO(10,128)*/
		opr[10]=(char)0x00;

		/* 1st line displayed for each data */
		fprintf(fp2,"%8s",fname);
		fprintf(fp2,"%2d%2d%2d%2d%2d",igon,ism1,ism2,irep,iax);
		fprintf(fp2,"%8.3f%8.0f%2d",ssp,fu,icc);
		fprintf(fp2,"%7.4f%6.1f%6.1f%5.2f%5.2f%5.2f\n",wl,kv,ma,ds,rs,ss);
		/* 2nd line displayed for each data */
		fprintf(fp2,"%10.4f%10.4f%10.4f%10.4f  ",t1,t2,sw,ft);
		fprintf(fp2,"%10s%8s%10s\n",samp,dei,opr);
	}
	fclose(fp2);
	fclose(fp1);
	return 0;
}
