/************/
/* "rint.c" */
/************/
/* converts binary data file from Rigaku RAD2 diffractometer */
/* to text data.  */
#undef MAC

#include <stdio.h>
#ifdef MAC
#include <console.h>
#endif

int main(int argc, char *argv[])
{
	FILE *fp1,*fp2;	/* file pointers for input and output */
	char buf[256];	/* buffer for input data */
	char sfname[256];	/* source file name */
	char dfname[13];	/* destination file name */
	int i;
	double d;
	
	#ifdef MAC
	argc=ccommand(&argv);
	#endif
	if (argc!=2) {
		printf("Input File Name : ");
		scanf("%s",sfname);
		argv[1]=sfname;
	}
	fp1=fopen(argv[1],"rb");
	if (fp1==NULL) {
		printf("Error: Could not open '%s'\n",argv[1]);
		return 1;
	}
	for (i=0,dfname[0]=' ';i<8 && argv[1][i]!=(char)0x00;i++) {
		dfname[i]=argv[1][i];
	}
	dfname[i]='.';
	dfname[i+1]='t';
	dfname[i+2]='x';
	dfname[i+3]='t';
	dfname[i+4]=(char)0x00;	/* destination file name is "?.txt" */
	fp2=fopen(dfname,"wt");
	if (fp2==NULL) {
		printf("Error: Could not open '%s'\n",dfname);
		fclose(fp1);
		return 1;
	}
	#ifndef MAC
	printf(" Converting Data ...\n");
	#endif
	while(!feof(fp1)) {
		fread(buf,sizeof(char),128,fp1);
		for (i=0;i<64;i++) {
			d = (unsigned char)buf[i*2]+256*(unsigned char)buf[i*2+1];
			d = d * d / 256;
			fprintf(fp2,"%6.0f\n",d);
		}
	}
	fclose(fp2);
	fclose(fp1);
	#ifndef MAC
	printf("... Finished.\n");
	#endif
	return 0;
}