/* "rint2.c" */
/*   converts intensity data file from Rigaku RAD2 diffractometer */
/*   to X-Y data */
/* by Takashi IDA, Nov.30, 2001 */

#include <stdio.h>

static int SelectData(int *pk)
{
	FILE *fp1;
	char buf[256],fname[9];
	int i,j,c,n;

	fp1=fopen("INDEX","rb");
	if (fp1==NULL) {
		printf("Error: Could not open the file 'INDEX'\n");
		return 1;
	}
	fread(buf,sizeof(char),128,fp1);
	n=(unsigned char)buf[0]+256*(unsigned char)buf[1];
	printf("*** RINT2.EXE ***\n");
	printf("\n");
	printf(" Total Number of Identified Data : %2d\n",n-1);
	for (i=1,c=0; i<n; i++,c++) {
		if (c==5) {
			printf("\n");
			c=0;
		}
		fread(buf,sizeof(char),128,fp1);	/*N(8)*/
		for (j=0; j<8;j++) fname[j]=buf[j];
		fname[8]=(char)0x00;
		printf(" [%2d] %8s",i,fname);
	}
	printf("\n");
	*pk=0;
	while ((*pk<1)||(n-1<*pk)) {
		printf(" Select No. of Data ( 1 - %2d) : ",n-1);
		scanf("%d",pk);
	}
	fclose(fp1);
	return 0;
}

int main(void)
{
	FILE *fp1,*fp2;
	char buf[256],fname[12];
	int err,i,k,ifn;
	double d,t,t1,t2,sw;

	err=SelectData(&k);
	if (err!=0) {
		return err;
	}

	fp1=fopen("INDEX","rb");
	if (fp1==NULL) {
		printf("Error: Could not open the file 'INDEX'\n");
		return 1;
	}
	for (i=0;i<k;i++) {
		fread(buf,sizeof(char),128,fp1);
	}
	fread(buf,sizeof(char),128,fp1);
	fclose(fp1);
	
	for (ifn=0;(ifn<8)&&(buf[ifn]!=' ');ifn++) fname[ifn]=buf[ifn];
	fname[ifn]=(char)0x00;
	t1=(unsigned char)buf[18]+256*(unsigned char)buf[19];	/*STARTANG(4/22)*/
	t1=t1*65536+((unsigned char)buf[20]+256*(unsigned char)buf[21]);
	t1/=1000;
	t2=(unsigned char)buf[22]+256*(unsigned char)buf[23];	/*STOANG(4/26)*/
	t2=t2*65536+((unsigned char)buf[24]+256*(unsigned char)buf[25]);
	t2/=1000;
	sw=(unsigned char)buf[30]+256*(unsigned char)buf[31];	/*SAMPLEWIDTH(4/34)*/
	sw=sw*65536+((unsigned char)buf[32]+256*(unsigned char)buf[33]);
	sw/=1000;

	fp1=fopen(fname,"rb");
	if (fp1==NULL) {
		printf("Error: Could not open the file '%s'\n",fname);
		return 1;
	}
	
	fname[ifn]='.';
	fname[ifn+1]='t';
	fname[ifn+2]='x';
	fname[ifn+3]='t';
	fname[ifn+4]=(char)0x00;

	fp2=fopen(fname,"wt");
	if (fp2==NULL) {
		printf("Error: Could not open the file '%s'\n",fname);
		fclose(fp1);
		return 1;
	}

	#ifndef MAC
	printf(" Converting Data ...\n");
	#endif
	for (t=t1; t<t2-1e-5; ) {
		fread(buf,sizeof(char),128,fp1);	/*N(8)*/
		for (i=0;(i<64)&&(t<t2-1e-5);i++) {
			d = (unsigned char)buf[i*2]+256*(unsigned char)buf[i*2+1];
			d = d * d / 256;
			fprintf(fp2,"%6.2f\t%6.0f\n",t,d);
			t+=sw;
		}
	}
	fclose(fp2);
	fclose(fp1);
	#ifndef MAC
	printf("... Finished.\n");
	#endif
	return 0;
}
